/* futebus example: 'S' channel master (service)

   License: CC0 - no rights reserved 

   How to use:
   1. create the bus: futebus bus
   2. run the master: ./Smaster
   3. run a process to monitor the bus: cat bus/S1
   4. run another process to send data to the bus: echo hello >>bus/S1
*/

#include <stdio.h>

int main()
{
	const char *fn = "bus/.S1";
	FILE *f;
	char *line, buf[1024];

	/* open the bus for append+read */
	f = fopen(fn, "a+");
	if (f == NULL) {
		fprintf(stderr, "failed to open '%s' for a+\n", fn);
		return 1;
	}

	/* main loop: read messages, print them on stdout and broadcast them back
	   (without removing the address prefix that an 'S' master gets).
	   The {*} prefix in the fprintf makes the output message broadcast;
	   message terminating newline is already at the end of line because
	   of fgets(). */
	while((line=fgets(buf, sizeof(buf), f)) != NULL) {
		printf("Read: %s", line);
		fprintf(f, "{*}Relaying message as received:");
		fprintf(f, "%s", line);
		fflush(f);
	}

	printf("<EOF>\n");
	fclose(f);
	printf("<exit 0>\n");
	return 0;
}
